#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "gram.y"
/* $Header: /local/src/CVS/nickle/gram.y,v 1.130 2004/04/16 05:26:45 keithp Exp $ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 2 reduce/reduce and 4 shift/reduce conflicts:
 * 
 * reduce/reduce conflict on:
 *
 *	    *int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  reduce/reduce conflict on:
 *
 *	   &int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict on NL:
 *
 *	    opt_nl : .
 *
 *	This says that you can have multiple NLs in a row
 *	and the grammar can't tell which opt_nl is reduced.
 *	No big deal.
 *
 *  shift/reduce conflict on CATCH:
 *
 *	That's because CATCH blocks are optional and chained.
 *	Shifting binds the CATCH to the nearest enclosing TRY,
 *	just like ELSE
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers
 *	(of course, you can always enclose an assignment in parens)
 *
 *  shift/reduce conflict on ELSE
 *
 *	Need we say more?
 */
int ignorenl;
int notCommand;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 80 "gram.y"
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#line 110 "gram.c"
#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define NL 265
#define SEMI 266
#define MOD 267
#define OC 268
#define CC 269
#define DOLLAR 270
#define DOTDOTDOT 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FILET 282
#define MUTEX 283
#define SEMAPHORE 284
#define CONTINUATION 285
#define THREAD 286
#define VOID 287
#define BOOL 288
#define FUNCTION 289
#define FUNC 290
#define EXCEPTION 291
#define RAISE 292
#define TYPEDEF 293
#define IMPORT 294
#define NEW 295
#define ANONINIT 296
#define NAMESPACE 297
#define PUBLIC 298
#define PROTECTED 299
#define EXTEND 300
#define IF 301
#define ELSE 302
#define WHILE 303
#define DO 304
#define FOR 305
#define SWITCH 306
#define BREAK 307
#define CONTINUE 308
#define RETURNTOK 309
#define FORK 310
#define CASE 311
#define DEFAULT 312
#define TRY 313
#define CATCH 314
#define TWIXT 315
#define NAME 316
#define TYPENAME 317
#define NAMESPACENAME 318
#define COMMAND 319
#define NAMECOMMAND 320
#define TEN_NUM 321
#define OCTAL0_NUM 322
#define OCTAL_NUM 323
#define BINARY_NUM 324
#define HEX_NUM 325
#define TEN_FLOAT 326
#define OCTAL0_FLOAT 327
#define OCTAL_FLOAT 328
#define BINARY_FLOAT 329
#define HEX_FLOAT 330
#define CHAR_CONST 331
#define STRING_CONST 332
#define POLY_CONST 333
#define THREAD_CONST 334
#define VOIDVAL 335
#define BOOLVAL 336
#define DARROW 337
#define POUND 338
#define COMMA 339
#define ASSIGN 340
#define ASSIGNPLUS 341
#define ASSIGNMINUS 342
#define ASSIGNTIMES 343
#define ASSIGNDIVIDE 344
#define ASSIGNDIV 345
#define ASSIGNMOD 346
#define ASSIGNPOW 347
#define ASSIGNSHIFTL 348
#define ASSIGNSHIFTR 349
#define ASSIGNLXOR 350
#define ASSIGNLAND 351
#define ASSIGNLOR 352
#define QUEST 353
#define COLON 354
#define OR 355
#define AND 356
#define LOR 357
#define LXOR 358
#define LAND 359
#define EQ 360
#define NE 361
#define LT 362
#define GT 363
#define LE 364
#define GE 365
#define SHIFTL 366
#define SHIFTR 367
#define PLUS 368
#define MINUS 369
#define TIMES 370
#define DIVIDE 371
#define DIV 372
#define POW 373
#define UNIONCAST 374
#define UMINUS 375
#define BANG 376
#define FACT 377
#define LNOT 378
#define INC 379
#define DEC 380
#define STAR 381
#define AMPER 382
#define THREADID 383
#define OS 384
#define CS 385
#define DOT 386
#define ARROW 387
#define STAROS 388
#define CALL 389
#define OP 390
#define CP 391
#define POINTER 392
#define COLONCOLON 393
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   87,   87,   90,   90,   91,   92,   89,   93,
   94,   94,   95,   95,   96,   96,   88,   88,   88,   88,
   88,   88,    2,    2,    4,    4,    3,    6,    6,    6,
    5,    5,   21,   21,    1,    1,   22,   22,   53,   53,
   97,   98,    7,   99,  100,   10,   10,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,  101,   11,   11,   11,   11,
   12,   12,   13,    8,    8,  102,    9,   14,   14,   15,
   16,   16,   17,   17,   18,   19,   19,   20,   20,   31,
   31,   27,   27,   29,   29,   34,   34,   28,   28,   30,
   37,   32,   33,   33,   33,   35,   35,   35,   36,   36,
   36,   36,   36,   36,   36,   40,   40,   40,   40,   40,
   40,   39,   39,   39,   41,   41,   41,   41,   41,   41,
   38,   38,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   42,   42,   43,   43,   44,   44,
   46,   46,   47,   47,   48,   48,   49,   49,   49,   49,
   50,   50,   51,   51,   52,   52,   54,   54,   55,   55,
   56,   56,   59,   57,   57,   58,   58,   60,   60,   61,
   61,   62,   62,   63,   63,   70,   70,   64,   64,   65,
   65,   68,   68,   69,   69,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
   71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
   71,   71,   71,   67,   67,   67,   67,   67,   67,   67,
   67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
   67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
   67,   67,   67,   67,   67,   72,   72,   73,   73,   73,
   73,   73,   74,   74,   74,   75,   75,   23,   23,   24,
   24,   25,   26,   76,   76,   77,   77,   78,   78,   78,
   79,   80,   80,   81,   81,   82,   82,   83,   84,   84,
   85,   85,   86,   86,   86,   86,
};
short yylen[] = {                                         2,
    2,    0,    1,    3,    1,    1,    0,    0,    0,    0,
    1,    0,    1,    0,    1,    0,    4,    6,    4,    6,
    6,    1,    1,    0,    3,    1,    2,    1,    1,    1,
    3,    0,    2,    1,    2,    1,    3,    2,    1,    1,
    0,    0,    3,    2,    2,    2,    0,    9,   11,    9,
   10,   13,    9,   10,    2,    2,    3,    2,    1,    1,
    3,    9,    6,    6,    7,    0,    9,    6,    5,   11,
    2,    0,    6,    1,    1,    0,    2,    1,    3,    3,
    2,    0,    4,    3,    3,    2,    0,    7,    3,    1,
    0,    3,    1,    3,    1,    1,    1,    4,    2,    1,
    1,    4,    3,    4,    4,    2,    2,    0,    5,    4,
    4,    3,    4,    3,    3,    2,    4,    4,    4,    4,
    0,    2,    2,    2,    1,    4,    4,    4,    3,    1,
    1,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    3,    1,    3,    1,
    3,    1,    4,    0,    4,    0,    1,    1,    1,    1,
    1,    0,    1,    1,    1,    1,    3,    2,    3,    2,
    2,    1,    3,    1,    0,    3,    2,    2,    1,    1,
    0,    1,    0,    1,    2,    1,    3,    1,    0,    3,
    1,    1,    0,    3,    2,    1,    3,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    5,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    6,
    8,    8,    8,    3,    6,    2,    1,    3,    3,    4,
    4,    4,    3,    3,    6,    1,    0,    1,    1,    1,
    1,    1,    1,    2,    0,    5,    9,    2,    1,    3,
    1,    1,    0,    3,    1,    1,    1,    1,    2,    0,
    4,    3,    1,    3,    2,    1,    1,    4,    3,    1,
    3,    3,    1,    1,    1,    2,
};
short yydefred[] = {                                      2,
    0,    9,   22,    1,    3,    0,    0,    0,    0,    0,
   60,    0,   41,    0,  157,  158,  159,  160,  133,  134,
  135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
    7,    0,  163,  164,  166,    7,    7,    7,    7,    7,
    0,    0,    0,    0,    7,    7,   39,   34,    0,    0,
    0,  245,  247,  246,  248,  249,  250,  252,  251,  253,
  254,  255,  256,  257,  258,    0,    0,    0,    0,    0,
    0,    0,    0,  267,    0,  244,   59,    9,  130,    0,
    0,   41,    0,    0,    0,    0,  125,    0,    0,    0,
    0,   36,    0,    0,    0,    0,    0,    5,    6,    4,
    0,    0,    7,    0,  278,  280,  279,  281,  282,  198,
   44,  266,  276,    0,    0,    0,   41,   41,   41,   41,
   41,   55,   56,    0,    0,    0,    0,  182,    0,    0,
    0,   41,   38,    9,  188,    0,    9,    0,   23,    0,
  124,    0,    0,  123,    0,    0,    0,    0,    0,  259,
    0,    0,    0,    0,    0,   33,    0,   35,   75,   42,
   74,    0,    0,    0,    0,  185,    0,   41,    0,    0,
    0,    0,  122,    0,    0,    0,    0,    0,    0,    7,
    0,    7,    7,    7,    7,    0,    0,    7,   58,    0,
    0,    0,  243,  231,  232,  233,  234,  235,  236,  237,
  238,  239,  240,  241,  242,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  204,  206,  208,    0,    0,
    0,    0,    0,    0,    0,   42,    0,    0,    0,  131,
    0,    0,    0,   41,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  100,   57,   72,    0,    0,    0,    0,
   32,   28,   30,   29,    0,    0,    0,    0,    0,    0,
  269,    0,    0,  268,   11,   19,   37,   61,    0,   78,
   77,    0,    0,    0,  174,    0,    0,  103,    0,    0,
    0,  264,  112,  150,    0,    0,    0,    0,    0,  168,
    0,    0,    0,  116,  124,  123,    0,    0,    0,  114,
    0,    0,    0,    0,    7,    0,  115,    0,    9,   17,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  273,  274,    0,    0,    0,  192,    0,
    0,   43,   46,    0,  126,    0,  127,    0,    0,  128,
  105,    0,    0,    0,    0,    0,    0,    0,    0,   13,
    0,  190,    0,   25,   31,    0,    0,    0,    0,    0,
    0,    0,    0,  178,  102,  180,    0,  177,  104,    0,
    0,  313,  315,  314,  107,  101,    0,    0,   76,    0,
    0,    0,    0,    0,  171,  167,    0,  170,  129,  110,
   41,   97,    0,    0,    0,    0,    0,  111,    0,  113,
   40,   66,    0,    0,  271,  270,    0,  195,  272,   45,
    0,    0,    0,   92,    0,    0,    0,    0,    0,    0,
    0,   71,   69,    0,   20,   21,   41,  147,   41,   41,
  151,    0,   42,   79,  176,  316,    0,    0,    0,    0,
    0,  295,    0,  303,    0,  310,  297,   98,    0,   42,
  120,  117,  149,  118,  119,  169,    0,    8,    0,   96,
    0,    8,  109,    0,   18,    0,  194,  153,  155,    0,
   63,    0,    0,    0,    0,    0,   41,    0,    0,    0,
    0,    0,  260,    0,    0,  305,  307,    0,    0,    0,
    0,    0,    0,    0,    0,  173,  275,   42,   64,   94,
    8,   68,    0,    0,    0,   42,    0,    0,   42,    0,
    0,    0,    0,   42,  298,    0,   42,    0,   42,  283,
    0,  312,  292,  293,    0,  304,    0,  294,    0,    0,
  302,  301,    0,  309,  308,    0,   65,    0,   42,    0,
    0,    8,    8,   42,    0,    8,    0,    0,   42,    0,
    0,    0,  299,  263,  261,  284,  262,    0,    0,  286,
    8,    8,    8,   41,    0,   42,    0,   42,   48,   50,
    8,    0,   53,    0,    0,   80,   81,   42,   42,    0,
  290,   62,   67,   54,    0,    0,   85,   86,    8,   51,
    0,    0,   84,   73,    8,    0,  289,   42,    0,   89,
   49,   42,   83,   70,  288,    0,   90,    0,    8,  287,
    0,   52,   42,   88,
};
short yydgoto[] = {                                       1,
   76,  137,  138,  139,  140,  265,   77,  160,  161,  236,
  237,  368,  442,  281,  529,  569,  570,  559,  586,  587,
   79,   80,  618,  544,  545,  578,  246,  166,  414,  167,
  628,   81,   82,  415,  290,   83,  397,   84,  129,  173,
   86,  296,  268,  298,   87,  269,  241,  243,   88,   89,
   90,   91,   92,  174,  302,  303,  284,  285,  399,  286,
  388,  127,  238,  134,  135,   94,   95,  348,  349,   96,
  229,  112,  110,  539,  392,  461,  462,  534,  393,  463,
  464,  506,  394,  465,  466,  467,    4,    5,    7,  100,
  170,  443,    6,  276,  371,  511,  111,  351,   97,  352,
  484,  162,
};
short yysindex[] = {                                      0,
   33,    0,    0,    0,    0, 1035,   90, -245, -226, -220,
    0,  296,    0,  296,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -57,    0,    0,    0,    0,    0,    0,    0,    0,
 -181, -133, 1398, 2505,    0,    0,    0,    0, -196, 2505,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2505, 2505, 2505, 2505, 2505,
 2505, 2505, -172,    0, 1277,    0,    0,    0,    0,  -91,
  -46,    0, -237,  -60, -148, -309,    0, 2757,   79, 2698,
    4,    0, -239, 4874,  164,  -58, 1156,    0,    0,    0,
 2757, 2757,    0,  -12,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    8,  -80,  -53,    0,    0,    0,    0,
    0,    0,    0,   77,   43, 2698,  121,    0, -148,  386,
 1156,    0,    0,    0,    0, 3108,    0,   61,    0,  196,
    0,   38,   38,    0,   38,   38,   38,   38,   38,    0,
 1900,   16, -283,   18,  148,    0,   39,    0,    0,    0,
    0, -228, 2757,   99,   29,    0,   98,    0,  126,  148,
 2021,  788,    0, -309, -196, 2757, 2757, 2757,   66,    0,
  148,    0,    0,    0,    0, 2757,  148,    0,    0, 1398,
  182, 2505,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2505, 2505, 2505, 2505, 2505,
 2505, 2505, 2505, 2505, 2505, 2505, 2505, 2505, 2505, 2505,
 2505, 2505, 2505, 2505, 2505,    0,    0,    0, 2505, 2505,
  135,  141, 2505, 2505, 2505,    0, 1156,  195,  -12,    0,
  194,  -12,  201,    0,  138,  209,   94, 2505,  100,  111,
 1156,  128,  130,    0,    0,    0,  134,  236, 2505,  236,
    0,    0,    0,    0,  123, 2505,  -11, -164,  145, 4712,
    0,  207,    0,    0,    0,    0,    0,    0, 2505,    0,
    0,  210,    0,  137,    0, -241,  142,    0, 2142,  197,
  151,    0,    0,    0,   20,  150,  199, -131,  157,    0,
  237,  166, -235,    0,    0,    0,  167,   39,  148,    0,
  244, 2744,  -57,  148,    0,  148,    0,  -25,    0,    0,
   89, 4767,  517,  895, 1019, 1134,  724,  270,  270,  638,
  638,  638,  638,  683,  683, 1201, 1201,   89,   89,   89,
   89, 4874,  178,    0,    0,  180, 4660,  179,    0, 4874,
  302,    0,    0,  306,    0,  308,    0,  186,  -12,    0,
    0,  190, 1398, 1398,  279, 1398, 1398,  269, 1398,    0,
  320,    0,  321,    0,    0,  200,  217,  202,  204, 2505,
  205,  322, 2926,    0,    0,    0, 2757,    0,    0, 1525,
 4874,    0,    0,    0,    0,    0,   43, 2757,    0, -309,
 -309,  317, -309, -309,    0,    0, 2757,    0,    0,    0,
    0,    0,    0,  331,  259,  112,  336,    0,  148,    0,
    0,    0,  343, 2505,    0,    0, 2505,    0,    0,    0,
 2757, 2757, 1398,    0,  344,  218,  220,  223,  348,  224,
  -57,    0,    0,  356,    0,    0,    0,    0,    0,    0,
    0, 2617,    0,    0,    0,    0,  284, 2142, -172, 4819,
  288,    0,  291,    0,  305,    0,    0,    0,  254,    0,
    0,    0,    0,    0,    0,    0,  257,    0,  112,    0,
  382,    0,    0,  383,    0,  386,    0,    0,    0,  265,
    0, 1156, 1156, 1398, 1398,  391,    0, 1398,  392,  393,
  397,  164,    0, 2142, 4874,    0,    0,  350, 2142, 2142,
  409, 2263,  404,  381,  429,    0,    0,    0,    0,    0,
    0,    0, 1156,  391,  414,    0,  345,  474,    0,  133,
  151,  369, 1652,    0,    0, 2384,    0, 1779,    0,    0,
 4874,    0,    0,    0,  424,    0, 4874,    0,  495, 4819,
    0,    0,  284,    0,    0,  501,    0,  499,    0,  155,
 1156,    0,    0,    0, 1398,    0, 1398,  415,    0,  133,
  391, 1156,    0,    0,    0,    0,    0,  385,  350,    0,
    0,    0,    0,    0,  419,    0,  155,    0,    0,    0,
    0,  384,    0,  420, 1156,    0,    0,    0,    0, -213,
    0,    0,    0,    0,  460, 1156,    0,    0,    0,    0,
 1156, 1156,    0,    0,    0, 2142,    0,    0,  461,    0,
    0,    0,    0,    0,    0,  510,    0,  431,    0,    0,
 1156,    0,    0,    0,
};
short yyrindex[] = {                                      0,
  914,    0,    0,    0,    0,  159,    0,    0,    0,    0,
    0,    0,    0, 2811,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -207,  493,    0,    0,    0,    0, 2866,   22,
   -9,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  493,  493,  493,  493,  493,
  493,  493,    0,    0,  493,    0,    0,    0,    0,    0,
 -197,    0,    0,    0,  -50, -179,    0, -240,  490,  310,
    0,    0,  525,  -71, 3175,   57,  143,    0,    0,    0,
 -250, -216,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -222,    0,    0,  506, 1607,
  159,    0,    0,    0,    0, -252,    0,  189,    0,    0,
    0, 3292, 3347,    0, 3402, 3457, 3512, 3567, 3622,    0,
  493,    0,  -43,    0,  654,    0, 2866,    0,    0,    0,
    0,    0, -298,    0,  -61,    0,   50,    0,    0, -188,
 -261,    0,    0, -179,    0,    0,    0,    0,    0,    0,
 -188,    0,    0,    0,    0, -240, -188,    0,    0,  493,
    0,  493,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  493,  493,  493,  493,  493,
  493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
  493,  493,  493,  493,  493,    0,    0,    0,  493,  493,
    0,    0,  493, -278,  493,    0,    6,    0,    0,    0,
    0,    0,    0,    0,   26,    0,    0, -270,    0,    0,
  159,    0,    0,    0,    0,    0,    0,  526,  493,  526,
    0,    0,    0,    0, -232, -123,  506,    0,    0,  412,
    0,    0, -142,    0,    0,    0,    0,    0,  493,    0,
    0,    0, -198,    0,    0,  413,    0,    0,  493,  193,
    0,    0,    0,    0,  506,    0,  426,    0,    0,    0,
 -249,    0,  413,    0,    0,    0,    0,    0, -188,    0,
    0,    0,    0, -188,    0, -188,    0,    0,    0,    0,
 3677,    0, 1852, 1478, 1731, 4502, 4447, 4337, 4392,  770,
 4172, 4227, 4282, 4062, 4117, 3952, 4007, 3732, 3787, 3842,
 3897, -208,    0,    0,    0,    0,  413,    0,    0,   85,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  493,  493,    0, -207,  493,  402, -207,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  493,
 4605,    0,    0,    0,    0,    0,  512,    0,    0,  493,
  165,    0,    0,    0,    0,    0,    0, -298,    0, -179,
 -179,    0, -179, -179,    0,    0,    0,    0,    0,    0,
    0,    0, -161,    0,  563,    0,    0,    0, -188,    0,
    0,    0,    0,  493,    0,    0,  493,    0,    0,    0,
 -250, -216,  493,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  493,    0,    0,    0,    0, 4553,  493,  519,  -70,
   93,    0,  597,    0,  597,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1973,    0,    0,    0,    0,
    0,  159,  159,  493, -207,    0,    0, -269, 2993,    0,
 3048, 3230,    0,  493,  -88,    0,    0,    0,  493,  -16,
  598,  -32,    0,  601,    0,    0,    0,    0,    0,    0,
    0,    0,  143,    0,  533,    0,    0,    0,    0,  602,
    0,    0,  493,    0,    0,  493,    0,  493,    0,    0,
  -67,    0,    0,    0,  487,    0,  -70,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  622,
  159,    0,    0,    0, -269,    0,  493,    0,    0,  602,
    0,  159,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  622,    0,    0,    0,
    0,    0,    0,    0,    6,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    6,    0,    0,    0,    0,
  159,    6,    0,    0,    0,  493,    0,    0,  540,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    6,    0,    0,    0,
};
short yygindex[] = {                                      0,
  -31,    0,    0,  634,    0,    0,  -73,    0,  500, -209,
    1,    0,    0,    0,    0,  328,    0,    0,  313,    0,
    0,  108,    0,  325,    0,    0, -201,  504, -370,    0,
    0,    0,    0,    0,    0,   13,    0,  -85,   -6, -168,
    0,    0,  735,    0,    0, -166,  476,  486,  -39,    0,
   27,    0,  -77,  448,  542,    0,  534,  521,  425,    0,
 -293, -319,    2,  717,  707,  119,  516,    0,  560,    0,
    0,    0,  978,    0,  -27,    0, -499,    0,  502,    0,
  488,  489,    0,    0,  485, -285,    0,    0,  -69,    0,
  957, -447,    0, -155,  752, -144,   32,  -54, -452, -358,
    0,    0,
};
#define YYTABLESIZE 5254
short yytable[] = {                                      85,
  115,  152,  158,  395,  299,  304,   78,   93,  155,  408,
  548,  132,  191,  191,  293,  239,  242,  132,  154,  132,
  132,  172,  101,  191,    7,  310,  189,  353,  132,  386,
  519,  317,   27,   27,  522,  386,   85,  354,  158,   13,
  356,  102,    7,  530,  128,  481,  439,  104,    7,  444,
  186,  164,  156,  428,   13,  125,  197,  197,  183,  141,
  197,  144,  197,  343,  258,  132,  346,  260,  153,  126,
   76,  560,  179,  557,  171,    7,  154,  282,  165,  103,
  172,  180,  132,  185,  122,  121,  186,  125,  280,  172,
   85,  121,  175,    7,  240,  240,  453,  387,  190,  132,
   12,  126,  272,  407,   96,  278,   27,  273,  520,  121,
  121,  279,  193,  163,  589,  590,  625,  131,  593,  185,
  189,  183,  129,  146,   85,   41,  616,   12,  197,  197,
  197,  256,  123,  602,  603,  604,  121,  121,  191,  116,
  179,  172,   76,  610,  267,  197,  129,  129,  249,  250,
  251,  252,  253,  410,   34,   34,  283,  434,  418,  121,
  420,  621,  130,  257,  295,  301,  132,  624,  136,  305,
  306,  307,  507,  129,  377,  528,  197,   96,  532,  315,
  306,  632,  197,   85,  142,  143,  145,  146,  147,  148,
  149,  319,  179,  186,  186,  179,  133,  179,  296,  291,
  296,  311,  125,  100,  100,  121,  121,  402,  179,  179,
  596,  121,  150,  451,    7,  148,  126,  549,  542,  159,
  378,    7,   34,  507,   47,  156,  157,  607,   34,  168,
   85,  471,  472,  179,  474,  475,   15,  169,    7,  131,
  422,  129,  129,  129,   85,  592,  131,  129,  129,  423,
  306,  365,   15,  403,   15,   24,   24,  132,   47,  144,
   49,  148,   47,  483,  157,    7,  186,  186,  296,  270,
  179,  311,    7,  132,   47,  358,  100,  100,  100,  179,
  235,  417,  186,  179,  179,  179,  189,  189,    2,  270,
   47,   93,  421,  179,   93,  132,  162,    3,  162,  162,
  188,  282,  162,  245,  382,  416,   32,   32,   32,  248,
  321,  132,  282,  558,  108,  108,   47,   47,  513,  186,
  515,  184,  184,  247,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,  102,  239,  242,  342,  270,  187,
  187,  270,  347,  350,   98,   99,   85,   85,  254,   85,
   85,   16,   85,   16,  436,  437,  136,  128,  440,  182,
  128,  183,  184,  376,  169,  125,  125,  136,  125,  125,
  283,  125,  156,  308,  145,  613,  255,  108,  108,  126,
  126,  283,  126,  126,  184,  126,  620,  383,  503,  261,
  301,    8,  623,  108,  400,  169,  271,  391,  274,  497,
  184,   47,  275,  226,  287,  517,  227,  228,  288,  179,
  116,  633,  187,  187,  240,  240,   85,  412,  480,  106,
  106,  277,  132,  162,  490,  162,  162,  289,  187,  162,
  108,  292,  477,  567,  568,  125,  320,  184,  132,  162,
  344,  162,  162,   26,   26,  162,  345,   99,   99,  126,
  189,  225,  355,  556,  226,  584,  585,  227,  228,  357,
  562,  563,  537,  540,  566,  187,  359,  360,  499,  574,
  500,  501,  575,  361,  577,   85,   85,   85,   85,  363,
  508,   85,  525,  526,  179,  527,  128,  598,  270,  128,
  364,  370,  106,  106,  583,  179,  125,  125,  460,  591,
  125,  262,  263,  264,  179,  375,   85,  366,  106,  367,
  126,  126,  381,  369,  126,  384,  617,  385,  531,  379,
   99,  389,   42,  609,  401,  396,  192,  377,  179,  179,
  398,  404,  486,  614,  615,  347,   99,  230,  116,  231,
  232,  233,  405,  234,   85,  106,  406,  409,   85,  411,
   85,  588,  425,  626,  426,   85,  128,  629,  594,  429,
  430,  431,  599,  432,    7,  433,  505,  125,  634,  125,
  435,  438,  441,   99,  445,  446,  448,  473,   85,  390,
  447,  126,  449,  126,  450,  452,  478,  479,    7,   85,
  161,  482,  161,  161,   85,   85,  161,  485,  492,  491,
  493,  622,  494,  495,  496,  605,  105,  106,  107,  108,
  109,  498,  541,  504,   85,    7,  510,  505,  547,  512,
  550,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  514,  516,  226,  172,  521,  227,  228,
  523,  550,  192,   12,  547,  524,  547,    8,   13,  533,
  536,    8,    8,    8,  538,  543,    8,    8,    8,    8,
    8,    8,  552,    8,    8,    8,    8,    8,    8,  386,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,  553,  555,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,  561,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,  547,  564,    8,    8,  206,  565,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  572,
    8,  226,  579,  580,  227,  228,  581,  582,  595,  600,
    8,    8,  606,  612,  611,  619,  627,    8,  630,    8,
    8,    8,  132,  192,  631,    8,  165,    8,   42,    9,
   14,    8,   42,   42,   42,  131,  152,   42,   42,   42,
   42,   42,   42,  181,   42,   42,   42,   42,   42,   42,
  145,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,  132,   95,   42,
   42,   42,   42,   42,   41,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   16,  181,   42,   42,   15,
   82,  291,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
   87,   42,  226,   91,  374,  227,  228,  597,  470,  608,
  468,   42,   42,  601,  192,  297,  488,  455,   42,   12,
   42,   42,   42,   12,   12,   12,   42,  489,   42,   12,
   12,   12,   42,   12,  518,   12,   12,   12,   12,   12,
   12,  469,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,  476,  192,
   12,   12,   12,   12,   12,  571,   12,   12,   12,   12,
   12,   12,   12,   12,  362,  372,   12,  502,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,  487,  114,   12,   12,
  192,  113,  117,  118,  119,  120,  121,  546,  554,  551,
  535,  131,  132,  218,  219,  220,  221,  222,  223,  224,
  225,  373,   12,  226,    0,    0,  227,  228,    0,    0,
    0,    0,   12,   12,    0,    0,    0,    0,    0,   12,
    0,   12,   12,   12,  227,  227,    0,   12,  227,   12,
  227,    0,    0,   12,  181,    0,  187,    8,  124,   10,
  220,  221,  222,  223,  224,  225,    0,    0,  226,  244,
    0,  227,  228,   19,   20,    0,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,    0,    0,    0,    0,
    0,    0,  187,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,    0,    0,  226,
    0,    0,  227,  228,   48,  175,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,    0,  309,    0,  311,  312,
  313,  314,  316,    0,  318,    0,  176,    0,    0,    0,
    0,    0,    0,    0,  227,    0,    0,  177,    0,    0,
  227,  192,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   10,   10,   10,    0,  178,  300,   10,
   10,   10,    0,   10,    0,   10,   10,   10,   10,   10,
   10,    0,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,    0,    0,
   10,   10,   10,   10,   10,    0,   10,   10,   10,   10,
   10,   10,   10,   10,    0,    0,   10,    0,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,    0,    0,   10,   10,
    0,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,    0,    0,
  226,  419,   10,  227,  228,    0,    0,    0,    0,    0,
    0,    0,   10,   10,    0,  192,    0,    0,    0,   10,
    0,   10,   10,   10,    8,    9,   10,   10,    0,   10,
   11,   12,   13,   10,   14,    0,   15,   16,   17,   18,
   19,   20,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,    0,    0,   32,    0,    0,    0,
    0,    0,   33,   34,   35,   36,    0,   37,   38,   39,
   40,   41,   42,   43,   44,    0,    0,   45,    0,   46,
   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,   64,
   65,    0,    0,    0,    0,    0,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,    0,   66,  226,    0,    0,  227,  228,    0,
  192,    0,    0,   67,   68,    0,    0,    0,    0,    0,
   69,    0,   70,   71,   72,    8,    9,   10,   73,    0,
   74,   11,   12,   13,   75,   14,    0,   15,   16,   17,
   18,   19,   20,    0,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,    0,    0,   32,    0,    0,
    0,    0,    0,   33,   34,   35,   36,    0,   37,   38,
   39,   40,   41,   42,   43,   44,    0,  192,   45,    0,
   46,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
   64,   65,  211,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,    0,    0,  226,
    0,    0,  227,  228,   66,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   67,   68,    0,    0,    0,    0,
    0,   69,    0,   70,   71,   72,    8,  124,   10,   73,
    0,   74,    0,   12,   13,   75,   14,    0,   15,   16,
   17,   18,   19,   20,    0,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,    0,    0,    0,    0,    0,
  222,  223,  224,  225,   33,   34,  226,    0,    0,  227,
  228,    0,    0,    0,    0,    0,   44,    0,    0,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,   64,   65,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   67,   68,    0,    0,    0,
    0,    0,   69,    0,   70,   71,   72,    8,  124,   10,
  151,    0,   74,    0,   12,    0,   75,   14,    0,   15,
   16,   17,   18,   19,   20,    0,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   33,   34,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   44,    0,    0,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,  223,  223,    0,    0,  223,    0,  223,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   67,   68,    0,    0,
    0,    0,    0,   69,    0,   70,   71,   72,    0,    0,
    0,   73,    0,   74,    8,  124,   10,   75,    0,    0,
    0,   12,  390,  456,   14,    0,    0,    0,    0,    0,
   19,   20,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,    0,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,   44,    0,    0,    0,    0,    0,
  457,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,   64,
   65,  458,  223,    0,    0,    0,    0,    0,  223,    0,
    0,  209,  209,    0,    0,  209,    0,  209,    0,    0,
    0,    0,    0,   66,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   67,   68,    0,    0,    0,    0,    0,
   69,    0,   70,   71,   72,    0,    0,    0,  459,    0,
   74,    8,  124,   10,   75,    0,    0,    0,   12,    0,
  573,   14,    0,    0,    0,    0,    0,   19,   20,    0,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
    0,    0,    0,  209,  209,  209,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,    0,
  209,   44,    0,    0,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,   64,   65,  458,    0,
    0,  209,    0,    0,    0,  222,  222,  209,    0,  222,
    0,  222,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   68,    0,    0,    0,    0,    0,   69,    0,   70,
   71,   72,    0,    0,    0,   73,    0,   74,    8,  124,
   10,   75,    0,    0,    0,   12,  390,  576,   14,    0,
    0,    0,    0,    0,   19,   20,    0,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,   44,    0,
    0,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,   64,   65,  222,  224,  224,    0,    0,
  224,  222,  224,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   67,   68,    0,
    0,    0,    0,    0,   69,    0,   70,   71,   72,    8,
  124,   10,  459,    0,   74,    0,   12,    0,   75,   14,
    0,    0,    0,    0,    0,   19,   20,    0,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,    0,    0,   44,
    0,    0,    0,    0,    0,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,   64,   65,  224,  219,  219,    0,
    0,  219,  224,  219,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   66,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   67,  266,
    0,    0,    0,    0,    0,   69,    0,   70,   71,   72,
    8,  124,   10,   73,  150,   74,    0,   12,    0,   75,
   14,  294,    0,    0,    0,    0,   19,   20,    0,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,  219,
  219,  219,  219,  219,  219,  219,  219,  219,  219,  219,
  219,  219,  219,  219,  219,    0,  219,    0,    0,    0,
   44,    0,    0,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,   64,   65,  219,    0,    0,
    0,    0,    0,  219,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   66,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   67,
  266,    0,    0,    0,    0,    0,   69,    0,   70,   71,
   72,    8,  124,   10,   73,    0,   74,    0,   12,  390,
   75,   14,    0,    0,    0,    0,    0,   19,   20,    0,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   44,    0,    0,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,   64,   65,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   68,    0,    0,    0,    0,    0,   69,    0,   70,
   71,   72,    8,  124,   10,   73,    0,   74,    0,   12,
    0,   75,   14,    0,    0,    0,    0,    0,   19,   20,
    0,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   44,    0,    0,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,   64,   65,  458,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   67,   68,    0,    0,    0,    0,    0,   69,    0,
   70,   71,   72,    8,  124,   10,   73,    0,   74,    0,
   12,  390,   75,   14,    0,    0,    0,    0,    0,   19,
   20,    0,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   44,    0,    0,    0,    0,    0,   47,
   48,   49,    0,    0,   52,   53,   54,   55,   56,   57,
   58,   59,   60,   61,   62,   63,    0,    0,   64,   65,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   67,   68,    0,    0,    0,    0,    0,   69,
    0,   70,   71,   72,    8,  124,   10,  459,    0,   74,
    0,   12,    0,   75,   14,    0,    0,    0,    0,    0,
   19,   20,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   44,    0,    0,    0,    0,    0,
   47,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,   64,
   65,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   67,   68,    0,    8,  124,   10,    0,
   69,    0,   70,   71,   72,    0,   14,    0,   73,    0,
   74,    0,   19,   20,   75,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,   64,   65,    0,    0,    0,    0,    8,  124,   10,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   15,
   16,   17,   18,   19,   20,  176,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,  177,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   73,    0,   74,    8,  124,   10,   75,    0,    0,    0,
    0,    0,    0,    0,   48,  175,    8,  124,   10,   19,
   20,    0,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   19,   20,    0,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  176,    0,    0,  412,
  413,  175,    0,    0,    0,    0,    0,  177,    0,    0,
    0,    0,    0,   48,  175,  277,  277,  277,    0,  277,
    0,  277,    0,    0,    0,    0,    0,  178,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  176,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  177,    0,  176,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  177,    0,    0,    0,
   40,   40,   40,  178,   40,    0,   40,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  178,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,    0,    0,  277,    0,    0,  277,
  277,  454,  192,    0,  277,  277,  277,  277,  277,    0,
  277,  277,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,    0,
    0,   40,    0,    0,   40,   40,    0,    0,    0,   40,
   40,   40,   40,   40,    0,   40,   40,  300,  300,  300,
    0,  300,    0,  300,    0,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  202,  203,  204,  205,  206,    0,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,    0,
    0,  226,    0,    0,  227,  228,    0,    0,    0,    0,
    0,    0,  285,  285,  285,    0,  285,    0,  285,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  300,
  300,  300,  300,  300,  300,  300,  300,  300,  300,  300,
  300,  300,  300,  300,  300,  300,  300,  300,  300,  300,
  300,  300,  300,  300,  300,  300,  300,  300,  300,  300,
  300,  300,  300,  300,  300,  300,    0,    0,  300,    0,
    0,  300,  300,    0,  192,    0,  300,  300,  300,  300,
  300,    0,  300,  300,  285,  285,  285,  285,  285,  285,
  285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
  285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
  285,  285,  285,  285,  285,  285,  285,  285,  285,  285,
  285,    0,    0,  285,    0,    0,  285,  285,    0,    0,
    0,  285,  285,  285,  285,  285,    0,  285,  285,  196,
  196,  196,    0,  196,    0,  196,  259,  193,  194,  195,
  196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
  206,    0,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,    0,    0,  226,    0,    0,  227,  228,    0,    0,
    0,    0,    0,    0,  265,  265,  265,    0,  265,    0,
  265,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  196,  196,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
  196,  196,  196,  196,  196,  196,  196,  196,    0,    0,
  196,    0,    0,  196,  196,    0,  200,  200,  200,  196,
  200,    0,  200,    0,    0,  196,  265,  265,  265,  265,
  265,  265,  265,  265,  265,  265,  265,  265,  265,  265,
  265,  265,  265,  265,  265,  265,  265,  265,  265,  265,
  265,  265,  265,  265,  265,  265,  265,  265,  265,  265,
  265,  265,  265,    0,    0,  265,    0,    0,  265,  265,
    0,  201,  201,  201,  265,  201,    0,  201,    0,    0,
  265,    0,    0,    0,    0,    0,    0,    0,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
  200,  200,  200,  200,  200,    0,  199,  199,  199,    0,
  199,    0,  199,    0,    0,    0,  200,    0,    0,    0,
    0,    0,  200,  201,  201,  201,  201,  201,  201,  201,
  201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
  201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
  201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
    0,  203,  203,  203,    0,  203,    0,  203,    0,    0,
    0,  201,    0,    0,    0,    0,    0,  201,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
  199,  199,  199,  199,  199,    0,  202,  202,  202,    0,
  202,    0,  202,    0,    0,    0,  199,    0,    0,    0,
    0,    0,  199,  203,  203,  203,  203,  203,  203,  203,
  203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
  203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
  203,  203,  203,  203,  203,  203,  203,  203,  203,  203,
    0,  205,  205,  205,    0,  205,    0,  205,    0,    0,
    0,  203,    0,    0,    0,    0,    0,  203,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
  202,  202,  202,  202,  202,    0,  207,  207,  207,    0,
  207,    0,  207,    0,    0,    0,  202,    0,    0,    0,
    0,    0,  202,  205,  205,  205,  205,  205,  205,  205,
  205,  205,  205,  205,  205,  205,  205,  205,  205,  205,
  205,  205,  205,  205,  205,  205,  205,  205,  205,  205,
  205,  205,  205,  205,  205,  205,  205,  205,  205,  205,
    0,  215,  215,  215,    0,  215,    0,  215,    0,    0,
    0,  205,    0,    0,    0,    0,    0,  205,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,    0,  212,  212,  212,    0,
  212,    0,  212,    0,    0,    0,  207,    0,    0,    0,
    0,    0,  207,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,    0,
    0,  213,  213,  213,    0,  213,    0,  213,    0,    0,
    0,  215,    0,    0,    0,    0,    0,  215,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
  212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
  212,  212,  212,  212,    0,    0,  214,  214,  214,    0,
  214,    0,  214,    0,    0,    0,  212,    0,    0,    0,
    0,    0,  212,  213,  213,  213,  213,  213,  213,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  213,    0,
    0,  216,  216,  216,    0,  216,    0,  216,    0,    0,
    0,  213,    0,    0,    0,    0,    0,  213,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
  214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
  214,  214,  214,  214,    0,    0,  210,  210,    0,    0,
  210,    0,  210,    0,    0,    0,  214,    0,    0,    0,
    0,    0,  214,  216,  216,  216,  216,  216,  216,  216,
  216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
  216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
  216,  216,  216,  216,  216,  216,  216,  216,  216,    0,
    0,  211,  211,    0,    0,  211,    0,  211,    0,    0,
    0,  216,    0,    0,    0,    0,    0,  216,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
  210,    0,    0,    0,    0,    0,  217,  217,    0,    0,
  217,    0,  217,    0,    0,    0,  210,    0,    0,    0,
    0,    0,  210,  211,  211,  211,  211,  211,  211,  211,
  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
  211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
  211,  211,  211,  211,  211,  211,    0,    0,    0,    0,
    0,  218,  218,    0,    0,  218,    0,  218,    0,    0,
    0,  211,    0,    0,    0,    0,    0,  211,  217,  217,
  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
  217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
  217,  217,  217,  217,  217,  217,  217,  217,  217,    0,
    0,    0,    0,    0,    0,    0,  228,  228,    0,    0,
  228,    0,  228,    0,    0,    0,  217,    0,    0,    0,
    0,    0,  217,  218,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,    0,    0,    0,    0,    0,    0,
    0,  229,  229,    0,    0,  229,    0,  229,    0,    0,
    0,  218,    0,    0,    0,    0,    0,  218,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  230,  230,    0,    0,
  230,    0,  230,    0,    0,    0,  228,    0,    0,    0,
    0,    0,  228,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  225,  225,    0,    0,  225,    0,  225,    0,    0,
    0,  229,    0,    0,    0,    0,    0,  229,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  226,  226,    0,    0,
  226,    0,  226,    0,    0,    0,  230,    0,    0,    0,
    0,    0,  230,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  221,  221,    0,    0,  221,    0,  221,    0,    0,
    0,  225,    0,    0,    0,    0,    0,  225,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  220,  220,    0,    0,
  220,    0,  220,    0,    0,    0,  226,    0,    0,    0,
    0,    0,  226,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   39,
    0,   39,    0,   39,    0,    0,    0,    0,    0,    0,
    0,  221,    0,    0,    0,    0,    0,  221,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  264,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  220,    0,    0,   39,
    0,   39,  220,   39,   39,   39,   39,   39,   39,   39,
   39,   39,   39,   39,   39,   39,    0,   39,   39,   39,
   39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
   39,   39,   39,   39,   39,   39,  192,    0,   39,    0,
  386,   39,   39,    0,    0,    0,   39,    0,   39,   39,
   39,    0,   39,  264,  264,  264,  264,  264,  264,  264,
  264,  264,  264,  264,  264,  264,  264,  264,    0,  264,
  264,  264,  264,  264,  264,  264,  264,  264,  264,  264,
  264,  264,  264,  264,  264,  264,  264,  264,  192,    0,
  264,    0,    0,  264,  264,    0,    0,    0,  264,    0,
  264,  264,  264,    0,  264,    0,    0,    0,  427,  193,
  194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
  204,  205,  206,    0,  207,  208,  209,  210,  211,  212,
  213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  192,    0,  226,    0,    0,  227,  228,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  380,  193,  194,  195,  196,  197,  198,  199,  200,  201,
  202,  203,  204,  205,  206,    0,  207,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  192,    0,  226,    0,    0,
  227,  228,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  193,  194,  195,  196,
  197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
  424,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  192,    0,  226,    0,    0,  227,  228,    0,    0,    0,
    0,    0,    0,    0,    0,  509,    0,    0,  193,  194,
  195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
  205,  206,    0,  207,  208,  209,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,    0,    0,  226,    0,    0,  227,  228,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  193,  194,  195,  196,  197,  198,  199,
  200,  201,  202,  203,  204,  205,  206,    0,  207,  208,
  209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,    0,    0,  226,
    0,    0,  227,  228,
};
short yycheck[] = {                                       6,
   32,   75,   80,  289,  171,  174,    6,    6,   78,  303,
  510,  290,  265,  266,  170,  101,  102,  316,  269,  290,
  290,  271,  268,   93,  265,  181,  266,  237,  290,  271,
  478,  187,  265,  266,  482,  271,   43,  239,  116,  268,
  242,  268,  265,  496,   43,  416,  366,  268,  289,  369,
   90,  289,  269,  347,  268,   43,  265,  266,  266,   66,
  269,   68,  271,  230,  134,  316,  233,  137,   75,   43,
  268,  524,  271,  521,  384,  316,   75,  163,  316,  306,
  390,   88,  290,   90,  266,  265,  126,   75,  162,  339,
   97,  271,  391,  316,  101,  102,  382,  339,  338,  316,
  289,   75,  386,  339,  266,  160,  339,  391,  479,  289,
  290,  340,  391,   82,  562,  563,  616,  316,  566,  126,
  391,  391,  265,  385,  131,  268,  340,  316,  337,  338,
  339,  131,  266,  581,  582,  583,  316,  317,  391,   32,
  339,  391,  340,  591,  151,  354,  289,  290,  117,  118,
  119,  120,  121,  309,  316,  317,  163,  359,  314,  339,
  316,  609,   44,  132,  171,  172,  290,  615,   50,  176,
  177,  178,  458,  316,  339,  495,  385,  339,  498,  186,
  269,  629,  391,  190,   66,   67,   68,   69,   70,   71,
   72,  190,  391,  265,  266,   88,  393,   90,  269,  168,
  271,  269,  190,  265,  266,  385,  386,  339,  101,  102,
  569,  391,  385,  380,  265,  339,  190,  511,  504,  266,
  385,  265,  384,  509,  316,  317,  318,  586,  390,  290,
  237,  400,  401,  126,  403,  404,  269,  386,  289,  290,
  318,  384,  385,  386,  251,  565,  290,  390,  391,  319,
  339,  251,  269,  385,  271,  265,  266,  290,  316,  266,
  318,  385,  316,  419,  318,  316,  338,  339,  339,  151,
  163,  339,  316,  290,  269,  244,  338,  339,  340,  172,
  339,  313,  354,  176,  177,  178,  265,  266,  256,  171,
  316,  266,  318,  186,  269,  290,  291,  265,  293,  294,
  297,  387,  297,  316,  273,  312,  316,  317,  318,  390,
  192,  290,  398,  523,  265,  266,  311,  312,  463,  391,
  465,  265,  266,  316,  206,  207,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  268,  431,  432,  229,  230,  265,
  266,  233,  234,  235,  265,  266,  363,  364,  316,  366,
  367,  269,  369,  271,  363,  364,  248,  366,  367,  291,
  369,  293,  294,  385,  386,  363,  364,  259,  366,  367,
  387,  369,  317,  318,  266,  595,  266,  338,  339,  363,
  364,  398,  366,  367,  338,  369,  606,  279,  453,  339,
  407,    0,  612,  354,  385,  386,  391,  289,  391,  441,
  354,  269,  265,  376,  316,  470,  379,  380,  390,  312,
  313,  631,  338,  339,  431,  432,  433,  316,  317,  265,
  266,  393,  290,  291,  433,  293,  294,  340,  354,  297,
  391,  316,  411,  311,  312,  433,  265,  391,  290,  291,
  316,  293,  294,  265,  266,  297,  316,  265,  266,  433,
  266,  373,  269,  518,  376,  311,  312,  379,  380,  269,
  525,  526,  500,  501,  529,  391,  339,  269,  447,  534,
  449,  450,  537,  390,  539,  492,  493,  494,  495,  390,
  459,  498,  492,  493,  387,  494,  495,  571,  380,  498,
  390,  266,  338,  339,  559,  398,  494,  495,  390,  564,
  498,  316,  317,  318,  407,  393,  523,  390,  354,  390,
  494,  495,  316,  390,  498,  316,  600,  391,  497,  385,
  338,  390,    0,  588,  385,  339,  267,  339,  431,  432,
  390,  385,  424,  598,  599,  427,  354,  384,  441,  386,
  387,  388,  316,  390,  561,  391,  391,  391,  565,  316,
  567,  561,  385,  618,  385,  572,  565,  622,  567,  391,
  269,  266,  572,  266,  265,  390,  458,  565,  633,  567,
  391,  303,  314,  391,  265,  265,  370,  271,  595,  268,
  391,  565,  391,  567,  391,  391,  266,  339,  289,  606,
  291,  266,  293,  294,  611,  612,  297,  265,  391,  266,
  391,  611,  390,  266,  391,  584,  321,  322,  323,  324,
  325,  266,  504,  340,  631,  316,  339,  509,  510,  339,
  512,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  339,  391,  376,  390,  266,  379,  380,
  268,  533,  267,    0,  536,  391,  538,  256,  268,  268,
  268,  260,  261,  262,  268,  316,  265,  266,  267,  268,
  269,  270,  269,  272,  273,  274,  275,  276,  277,  271,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  316,  269,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  302,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  616,  391,  335,  336,  353,  266,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  391,
  359,  376,  339,  269,  379,  380,  266,  269,  354,  385,
  369,  370,  354,  354,  391,  316,  316,  376,  269,  378,
  379,  380,  290,  267,  354,  384,  297,  386,  256,  265,
  265,  390,  260,  261,  262,  290,  385,  265,  266,  267,
  268,  269,  270,  391,  272,  273,  274,  275,  276,  277,
  385,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  316,  266,  297,
  298,  299,  300,  301,  316,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  269,  269,  335,  336,  269,
  269,  385,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  269,  359,  376,  354,  261,  379,  380,  570,  399,  587,
  397,  369,  370,  579,  267,  171,  431,  387,  376,  256,
  378,  379,  380,  260,  261,  262,  384,  432,  386,  266,
  267,  268,  390,  270,  477,  272,  273,  274,  275,  276,
  277,  398,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  407,  267,
  297,  298,  299,  300,  301,  531,  303,  304,  305,  306,
  307,  308,  309,  310,  248,  259,  313,  452,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  427,   31,  335,  336,
  267,   14,   36,   37,   38,   39,   40,  509,  514,  512,
  499,   45,   46,  366,  367,  368,  369,  370,  371,  372,
  373,  260,  359,  376,   -1,   -1,  379,  380,   -1,   -1,
   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,  376,
   -1,  378,  379,  380,  265,  266,   -1,  384,  269,  386,
  271,   -1,   -1,  390,   88,   -1,   90,  260,  261,  262,
  368,  369,  370,  371,  372,  373,   -1,   -1,  376,  103,
   -1,  379,  380,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,
   -1,   -1,  126,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,   -1,   -1,  376,
   -1,   -1,  379,  380,  317,  318,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,   -1,  180,   -1,  182,  183,
  184,  185,  186,   -1,  188,   -1,  359,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  385,   -1,   -1,  370,   -1,   -1,
  391,  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,  261,  262,   -1,  390,  391,  266,
  267,  268,   -1,  270,   -1,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,   -1,   -1,
  297,  298,  299,  300,  301,   -1,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,   -1,  313,   -1,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,   -1,  335,  336,
   -1,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,   -1,   -1,
  376,  315,  359,  379,  380,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  369,  370,   -1,  267,   -1,   -1,   -1,  376,
   -1,  378,  379,  380,  260,  261,  262,  384,   -1,  386,
  266,  267,  268,  390,  270,   -1,  272,  273,  274,  275,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,
   -1,   -1,  298,  299,  300,  301,   -1,  303,  304,  305,
  306,  307,  308,  309,  310,   -1,   -1,  313,   -1,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,   -1,   -1,  335,
  336,   -1,   -1,   -1,   -1,   -1,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,   -1,  359,  376,   -1,   -1,  379,  380,   -1,
  267,   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,
  376,   -1,  378,  379,  380,  260,  261,  262,  384,   -1,
  386,  266,  267,  268,  390,  270,   -1,  272,  273,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,   -1,   -1,  298,  299,  300,  301,   -1,  303,  304,
  305,  306,  307,  308,  309,  310,   -1,  267,  313,   -1,
  315,  316,  317,  318,   -1,   -1,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,   -1,   -1,
  335,  336,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,   -1,   -1,  376,
   -1,   -1,  379,  380,  359,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,
   -1,  376,   -1,  378,  379,  380,  260,  261,  262,  384,
   -1,  386,   -1,  267,  268,  390,  270,   -1,  272,  273,
  274,  275,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,
  370,  371,  372,  373,  298,  299,  376,   -1,   -1,  379,
  380,   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,
   -1,   -1,  316,  317,  318,   -1,   -1,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,   -1,
   -1,  335,  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,   -1,
   -1,   -1,  376,   -1,  378,  379,  380,  260,  261,  262,
  384,   -1,  386,   -1,  267,   -1,  390,  270,   -1,  272,
  273,  274,  275,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,
   -1,   -1,   -1,  316,  317,  318,   -1,   -1,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
   -1,   -1,  335,  336,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,   -1,   -1,
   -1,   -1,   -1,  376,   -1,  378,  379,  380,   -1,   -1,
   -1,  384,   -1,  386,  260,  261,  262,  390,   -1,   -1,
   -1,  267,  268,  269,  270,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  310,   -1,   -1,   -1,   -1,   -1,
  316,  317,  318,   -1,   -1,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,   -1,   -1,  335,
  336,  337,  385,   -1,   -1,   -1,   -1,   -1,  391,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,
  376,   -1,  378,  379,  380,   -1,   -1,   -1,  384,   -1,
  386,  260,  261,  262,  390,   -1,   -1,   -1,  267,   -1,
  269,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
   -1,   -1,   -1,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,   -1,
  354,  310,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
   -1,   -1,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,   -1,   -1,  335,  336,  337,   -1,
   -1,  385,   -1,   -1,   -1,  265,  266,  391,   -1,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  369,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,
  379,  380,   -1,   -1,   -1,  384,   -1,  386,  260,  261,
  262,  390,   -1,   -1,   -1,  267,  268,  269,  270,   -1,
   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  310,   -1,
   -1,   -1,   -1,   -1,  316,  317,  318,   -1,   -1,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
  332,   -1,   -1,  335,  336,  385,  265,  266,   -1,   -1,
  269,  391,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,   -1,
   -1,   -1,   -1,   -1,  376,   -1,  378,  379,  380,  260,
  261,  262,  384,   -1,  386,   -1,  267,   -1,  390,  270,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,   -1,   -1,  310,
   -1,   -1,   -1,   -1,   -1,  316,  317,  318,   -1,   -1,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  331,  332,   -1,   -1,  335,  336,  385,  265,  266,   -1,
   -1,  269,  391,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,  370,
   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,  379,  380,
  260,  261,  262,  384,  385,  386,   -1,  267,   -1,  390,
  270,  271,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,   -1,  354,   -1,   -1,   -1,
  310,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,   -1,
   -1,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,   -1,   -1,  335,  336,  385,   -1,   -1,
   -1,   -1,   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,
  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,  379,
  380,  260,  261,  262,  384,   -1,  386,   -1,  267,  268,
  390,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,  317,  318,
   -1,   -1,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,   -1,   -1,  335,  336,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  369,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,
  379,  380,  260,  261,  262,  384,   -1,  386,   -1,  267,
   -1,  390,  270,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,  317,
  318,   -1,   -1,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,   -1,   -1,  335,  336,  337,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,  376,   -1,
  378,  379,  380,  260,  261,  262,  384,   -1,  386,   -1,
  267,  268,  390,  270,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  310,   -1,   -1,   -1,   -1,   -1,  316,
  317,  318,   -1,   -1,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,   -1,   -1,  335,  336,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  369,  370,   -1,   -1,   -1,   -1,   -1,  376,
   -1,  378,  379,  380,  260,  261,  262,  384,   -1,  386,
   -1,  267,   -1,  390,  270,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,   -1,   -1,
  316,  317,  318,   -1,   -1,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  331,  332,   -1,   -1,  335,
  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  369,  370,   -1,  260,  261,  262,   -1,
  376,   -1,  378,  379,  380,   -1,  270,   -1,  384,   -1,
  386,   -1,  276,  277,  390,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  316,  317,  318,   -1,   -1,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,  331,  332,   -1,
   -1,  335,  336,   -1,   -1,   -1,   -1,  260,  261,  262,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,
  273,  274,  275,  276,  277,  359,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  370,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  384,   -1,  386,  260,  261,  262,  390,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  317,  318,  260,  261,  262,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  359,   -1,   -1,  316,
  317,  318,   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,
   -1,   -1,   -1,  317,  318,  265,  266,  267,   -1,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  359,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  370,   -1,  359,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,
  265,  266,  267,  390,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  390,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,   -1,   -1,  376,   -1,   -1,  379,
  380,  266,  267,   -1,  384,  385,  386,  387,  388,   -1,
  390,  391,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,   -1,
   -1,  376,   -1,   -1,  379,  380,   -1,   -1,   -1,  384,
  385,  386,  387,  388,   -1,  390,  391,  265,  266,  267,
   -1,  269,   -1,  271,   -1,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,   -1,
   -1,  376,   -1,   -1,  379,  380,   -1,   -1,   -1,   -1,
   -1,   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,   -1,   -1,  376,   -1,
   -1,  379,  380,   -1,  267,   -1,  384,  385,  386,  387,
  388,   -1,  390,  391,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,   -1,   -1,  376,   -1,   -1,  379,  380,   -1,   -1,
   -1,  384,  385,  386,  387,  388,   -1,  390,  391,  265,
  266,  267,   -1,  269,   -1,  271,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,   -1,   -1,  376,   -1,   -1,  379,  380,   -1,   -1,
   -1,   -1,   -1,   -1,  265,  266,  267,   -1,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,   -1,   -1,
  376,   -1,   -1,  379,  380,   -1,  265,  266,  267,  385,
  269,   -1,  271,   -1,   -1,  391,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,   -1,   -1,  376,   -1,   -1,  379,  380,
   -1,  265,  266,  267,  385,  269,   -1,  271,   -1,   -1,
  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,   -1,  265,  266,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,   -1,  265,  266,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,   -1,  265,  266,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,   -1,  265,  266,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,   -1,
   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,   -1,   -1,  265,  266,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,   -1,
   -1,  265,  266,  267,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,   -1,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,  391,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,
   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,  391,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,  337,
   -1,  339,  391,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,   -1,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  267,   -1,  376,   -1,
  271,  379,  380,   -1,   -1,   -1,  384,   -1,  386,  387,
  388,   -1,  390,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  267,   -1,
  376,   -1,   -1,  379,  380,   -1,   -1,   -1,  384,   -1,
  386,  387,  388,   -1,  390,   -1,   -1,   -1,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  267,   -1,  376,   -1,   -1,  379,  380,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  267,   -1,  376,   -1,   -1,
  379,  380,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  267,   -1,  376,   -1,   -1,  379,  380,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  337,   -1,   -1,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,   -1,   -1,  376,   -1,   -1,  379,  380,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,   -1,   -1,  376,
   -1,   -1,  379,  380,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 393
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","NL","SEMI","MOD","OC","CC","DOLLAR","DOTDOTDOT",
"GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL","RATIONAL","REAL",
"STRING","FILET","MUTEX","SEMAPHORE","CONTINUATION","THREAD","VOID","BOOL",
"FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT","NEW","ANONINIT",
"NAMESPACE","PUBLIC","PROTECTED","EXTEND","IF","ELSE","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TRY","CATCH",
"TWIXT","NAME","TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM",
"OCTAL0_NUM","OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT",
"OCTAL_FLOAT","BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST",
"POLY_CONST","THREAD_CONST","VOIDVAL","BOOLVAL","DARROW","POUND","COMMA",
"ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES","ASSIGNDIVIDE","ASSIGNDIV",
"ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL","ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND",
"ASSIGNLOR","QUEST","COLON","OR","AND","LOR","LXOR","LAND","EQ","NE","LT","GT",
"LE","GE","SHIFTL","SHIFTR","PLUS","MINUS","TIMES","DIVIDE","DIV","POW",
"UNIONCAST","UMINUS","BANG","FACT","LNOT","INC","DEC","STAR","AMPER","THREADID",
"OS","CS","DOT","ARROW","STAROS","CALL","OP","CP","POINTER","COLONCOLON",
};
char *yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"statement : IF ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"statement : IF ignorenl namespace_start OP expr CP statement ELSE statement namespace_end attendnl",
"statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"statement : FOR ignorenl namespace_start OP opt_expr SEMI opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"statement : UNION SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"statement : BREAK SEMI",
"statement : CONTINUE SEMI",
"statement : RETURNTOK opt_expr SEMI",
"statement : expr SEMI",
"statement : block",
"statement : SEMI",
"statement : func_decl opt_func_body namespace_end",
"statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end SEMI attendnl",
"statement : RAISE fullname OP opt_exprs CP SEMI",
"statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"statement : opt_publish IMPORT ignorenl fullname SEMI attendnl",
"statement : TRY ignorenl statement catches attendnl",
"statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : ASSIGN simpleexpr SEMI",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish class type ignorenl opt_nl",
"decl : class type ignorenl opt_nl",
"decl : publish type ignorenl opt_nl",
"decl : type ignorenl opt_nl",
"decl : publish class ignorenl opt_nl",
"decl : class ignorenl opt_nl",
"decl : publish ignorenl opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : LAND type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : argdefines",
"opt_argdefines :",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"simpleexpr : primary",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr POW simpleexpr",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGN",
"primary : fullname",
"primary : TEN_NUM",
"primary : OCTAL_NUM",
"primary : OCTAL0_NUM",
"primary : BINARY_NUM",
"primary : HEX_NUM",
"primary : TEN_FLOAT",
"primary : OCTAL_FLOAT",
"primary : OCTAL0_FLOAT",
"primary : BINARY_FLOAT",
"primary : HEX_FLOAT",
"primary : CHAR_CONST",
"primary : STRING_CONST",
"primary : VOIDVAL",
"primary : BOOLVAL",
"primary : OS CS",
"primary : OP type CP namespace_start init namespace_end",
"primary : OP OS stars CS CP namespace_start arrayinit namespace_end",
"primary : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"primary : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"primary : type DOT NAME",
"primary : OP type DOT NAME CP primary",
"primary : DOLLAR opt_integer",
"primary : DOT",
"primary : OP expr CP",
"primary : OP block CP",
"primary : primary STAROS dims CS",
"primary : primary OS dims CS",
"primary : primary OP opt_actuals CP",
"primary : primary DOT NAME",
"primary : primary ARROW NAME",
"primary : opt_type FUNC namespace_start args func_body namespace_end",
"opt_integer : integer",
"opt_integer :",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1496 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ParseError ("%s before %S", msg, yytext);
}
#line 2435 "gram.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 197 "gram.y"
{ yyerrok; }
break;
case 6:
#line 199 "gram.y"
{ yyerrok; }
break;
case 7:
#line 207 "gram.y"
{ ignorenl++; }
break;
case 8:
#line 210 "gram.y"
{ ignorenl--; }
break;
case 9:
#line 213 "gram.y"
{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
		    }
break;
case 10:
#line 223 "gram.y"
{ notCommand = 1; }
break;
case 17:
#line 238 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yyvsp[-2].expr, 0));
			GetNamespace (&s, &f);
			t = NewThread (f, CompileExpr (e, 0));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 18:
#line 253 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yyvsp[-4].expr, 0), yyvsp[-2].expr);
			GetNamespace (&s, &f);
			t = NewThread (f, CompileExpr (e, 0));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 268 "gram.y"
{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr    f;
			Value	    t;
			
			GetNamespace (&s, &f);
			t = NewThread (f, CompileStat (yyvsp[-2].expr, 0));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 280 "gram.y"
{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CommandPtr	c;

			c = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!c)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, c->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f);
			    t = NewThread (f, CompileExpr (e, 0));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 21:
#line 303 "gram.y"
{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CommandPtr	c;

			c = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!c)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, c->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f);
			    t = NewThread (f, CompileExpr (e, 0));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 24:
#line 330 "gram.y"
{ yyval.expr = 0; }
break;
case 25:
#line 333 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 26:
#line 335 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 27:
#line 338 "gram.y"
{ yyval.expr = BuildRawname (yyvsp[-1].expr, yyvsp[0].atom); }
break;
case 31:
#line 345 "gram.y"
{ yyval.expr = NewExprTree (COLONCOLON, yyvsp[-2].expr, NewExprAtom (yyvsp[-1].atom, 0, False)); }
break;
case 32:
#line 347 "gram.y"
{ yyval.expr = 0; }
break;
case 33:
#line 350 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 34:
#line 355 "gram.y"
{ 
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 35:
#line 361 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 366 "gram.y"
{
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 372 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yyvsp[-2].expr, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 38:
#line 395 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 41:
#line 425 "gram.y"
{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 42:
#line 428 "gram.y"
{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 43:
#line 431 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 46:
#line 438 "gram.y"
{ yyval.expr = NewExprTree(OC, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 47:
#line 440 "gram.y"
{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 48:
#line 443 "gram.y"
{ yyval.expr = NewExprTree(IF, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 49:
#line 445 "gram.y"
{ yyval.expr = NewExprTree(ELSE, yyvsp[-6].expr, NewExprTree(ELSE, yyvsp[-4].expr, yyvsp[-2].expr)); }
break;
case 50:
#line 447 "gram.y"
{ yyval.expr = NewExprTree(WHILE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 51:
#line 449 "gram.y"
{ yyval.expr = NewExprTree(DO, yyvsp[-6].expr, yyvsp[-3].expr); }
break;
case 52:
#line 451 "gram.y"
{ yyval.expr = NewExprTree(FOR, NewExprTree(FOR, yyvsp[-8].expr, yyvsp[-6].expr),
				       NewExprTree(FOR, yyvsp[-4].expr, yyvsp[-2].expr));
		    }
break;
case 53:
#line 455 "gram.y"
{ yyval.expr = NewExprTree (SWITCH, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 54:
#line 457 "gram.y"
{ yyval.expr = NewExprTree (UNION, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 55:
#line 459 "gram.y"
{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 56:
#line 461 "gram.y"
{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 57:
#line 463 "gram.y"
{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yyvsp[-1].expr); }
break;
case 58:
#line 465 "gram.y"
{ yyval.expr = NewExprTree(EXPR, yyvsp[-1].expr, (Expr *) 0); }
break;
case 60:
#line 468 "gram.y"
{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 61:
#line 470 "gram.y"
{ 
			DeclList    *decl = yyvsp[-2].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yyvsp[-2].funcDecl.type.class;
			Publish	    publish = yyvsp[-2].funcDecl.type.publish;
			TypePtr	    type = yyvsp[-2].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yyvsp[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yyvsp[-1].expr),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 62:
#line 496 "gram.y"
{ 
			DeclListPtr decl;

			decl = NewDeclList (yyvsp[-5].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yyvsp[-8].publish, 
						       class_exception, 
						       typePoly, yyvsp[-5].atom);
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yyvsp[-3].argType),
					  yyvsp[-8].publish);
		    }
break;
case 63:
#line 510 "gram.y"
{ yyval.expr = NewExprTree (RAISE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 64:
#line 512 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, 0, yyvsp[-5].publish), 0);
		    }
break;
case 65:
#line 521 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-6].publish, class_typedef,
							   yyvsp[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, yyvsp[-3].type, yyvsp[-6].publish), 0);
		    }
break;
case 66:
#line 530 "gram.y"
{
			SymbolPtr   symbol;
			Publish	    publish = yyvsp[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yyvsp[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yyvsp[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yyvsp[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yyvsp[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].publish, class_namespace,
						     0, yyvsp[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yyvsp[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 67:
#line 571 "gram.y"
{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yyvsp[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yyvsp[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yyvsp[-5].atom, 0, False), yyvsp[-2].expr);
		    }
break;
case 68:
#line 585 "gram.y"
{
			SymbolPtr	symbol;
			ExprPtr		e;

			e = yyvsp[-2].expr;
			if (yyvsp[-2].expr->base.tag == COLONCOLON)
			    e = e->tree.right;
			symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace %A", e->atom.atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", e->atom.atom);
			    YYERROR;
			}
			NamespaceImport (CurrentNamespace, 
					 symbol->namespace.namespace, yyvsp[-5].publish);
			yyval.expr = NewExprTree (IMPORT, yyvsp[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yyvsp[-5].publish));
		    }
break;
case 69:
#line 612 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[-2].expr); }
break;
case 70:
#line 614 "gram.y"
{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yyvsp[-6].expr, yyvsp[-4].expr),
					NewExprTree (TWIXT, yyvsp[-2].expr, 0));
		    }
break;
case 71:
#line 620 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 72:
#line 622 "gram.y"
{ yyval.expr = 0; }
break;
case 73:
#line 625 "gram.y"
{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void], yyvsp[-2].argType, yyvsp[-1].expr), yyvsp[-4].expr); }
break;
case 75:
#line 629 "gram.y"
{ yyval.expr = 0; }
break;
case 76:
#line 631 "gram.y"
{ ++funcDepth; }
break;
case 77:
#line 631 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 78:
#line 634 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 79:
#line 636 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 80:
#line 643 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 81:
#line 646 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 82:
#line 648 "gram.y"
{ yyval.expr = 0; }
break;
case 83:
#line 651 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 84:
#line 653 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 85:
#line 656 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 86:
#line 659 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 87:
#line 661 "gram.y"
{ yyval.expr = 0; }
break;
case 88:
#line 664 "gram.y"
{ 
			SymbolPtr   sym = yyvsp[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yyvsp[-4].atom, 0, False),
						       name),
					  yyvsp[-1].expr);
		    }
break;
case 89:
#line 679 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 90:
#line 682 "gram.y"
{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yyvsp[0].atom);
		    }
break;
case 91:
#line 689 "gram.y"
{ yyval.symbol = 0; }
break;
case 92:
#line 695 "gram.y"
{ yyval.atomList = NewAtomList (yyvsp[0].atomList, yyvsp[-2].atom); }
break;
case 93:
#line 697 "gram.y"
{ yyval.atomList = NewAtomList (0, yyvsp[0].atom); }
break;
case 94:
#line 700 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[-2].atom, 0, yyvsp[0].declList); }
break;
case 95:
#line 702 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[0].atom, 0, 0); }
break;
case 98:
#line 715 "gram.y"
{ 
			if (yyvsp[-3].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-3].symbol->symbol.name, yyvsp[-2].expr, yyvsp[0].declList); 
			    yyval.declList->symbol = yyvsp[-3].symbol;
			}
			else
			    yyval.declList = yyvsp[0].declList;
		    }
break;
case 99:
#line 725 "gram.y"
{ 
			if (yyvsp[-1].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-1].symbol->symbol.name, yyvsp[0].expr, 0);
			    yyval.declList->symbol = yyvsp[-1].symbol;
			}
			else
			    yyvsp[-1].symbol = 0;
		    }
break;
case 100:
#line 736 "gram.y"
{	
			yyval.symbol = ParseNewSymbol (yyvsp[-1].fulltype.publish,
					     yyvsp[-1].fulltype.class,
					     yyvsp[-1].fulltype.type,
					     yyvsp[0].atom);
		    }
break;
case 101:
#line 748 "gram.y"
{ yyval.fulltype = yyvsp[-3].fulltype; }
break;
case 102:
#line 754 "gram.y"
{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yyvsp[-3].funcDecl.type.type, yyvsp[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yyvsp[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yyvsp[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].funcDecl.type.publish,
						     yyvsp[-3].funcDecl.type.class, 
						     type,
						     yyvsp[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yyvsp[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 103:
#line 787 "gram.y"
{ yyval.funcDecl.type = yyvsp[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 104:
#line 789 "gram.y"
{ yyval.funcDecl.type = yyvsp[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 105:
#line 791 "gram.y"
{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); 
		    }
break;
case 106:
#line 799 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 107:
#line 801 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 108:
#line 803 "gram.y"
{ yyval.expr = 0; }
break;
case 109:
#line 809 "gram.y"
{ yyval.fulltype.publish = yyvsp[-4].publish; yyval.fulltype.class = yyvsp[-3].class; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 110:
#line 811 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-3].class; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 111:
#line 813 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 112:
#line 815 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-2].type; }
break;
case 113:
#line 817 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = typePoly; }
break;
case 114:
#line 819 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = typePoly; }
break;
case 115:
#line 821 "gram.y"
{ yyval.fulltype.publish = yyvsp[-2].publish; yyval.fulltype.class = class_undef; yyval.fulltype.type = typePoly; }
break;
case 116:
#line 827 "gram.y"
{ yyval.type = NewTypeFunc (yyvsp[0].type, yyvsp[-1].argType); }
break;
case 117:
#line 829 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 118:
#line 831 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, True); }
break;
case 119:
#line 833 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 120:
#line 835 "gram.y"
{ yyval.type = NewTypeHash (yyvsp[0].type, yyvsp[-2].type); }
break;
case 121:
#line 837 "gram.y"
{ yyval.type = 0; }
break;
case 122:
#line 840 "gram.y"
{
			Type	*top = yyvsp[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yyvsp[-1].type;
			yyval.type = top;
		    }
break;
case 123:
#line 868 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, True); }
break;
case 124:
#line 870 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, False); }
break;
case 126:
#line 874 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 127:
#line 900 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 128:
#line 926 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 129:
#line 947 "gram.y"
{ yyval.type = yyvsp[-1].type; }
break;
case 130:
#line 949 "gram.y"
{ yyval.type = NewTypeName (yyvsp[0].expr, 0); }
break;
case 132:
#line 953 "gram.y"
{ yyval.type = typePoly; }
break;
case 146:
#line 970 "gram.y"
{ yyval.expr = 0; }
break;
case 147:
#line 973 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 148:
#line 975 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 149:
#line 978 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 150:
#line 980 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 151:
#line 983 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 152:
#line 985 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 153:
#line 991 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 154:
#line 993 "gram.y"
{ yyval.memList = 0; }
break;
case 155:
#line 996 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 156:
#line 998 "gram.y"
{ yyval.memList = 0; }
break;
case 162:
#line 1011 "gram.y"
{ yyval.publish = publish_private; }
break;
case 167:
#line 1025 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 168:
#line 1027 "gram.y"
{ yyval.argType = 0; }
break;
case 169:
#line 1030 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 170:
#line 1032 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 171:
#line 1035 "gram.y"
{ 
			ParseCanonType (yyvsp[-1].type, False);
			yyval.argDecl.type = yyvsp[-1].type; 
			yyval.argDecl.name = yyvsp[0].atom; 
		    }
break;
case 172:
#line 1041 "gram.y"
{ 
			ParseCanonType (yyvsp[0].type, False);
			yyval.argDecl.type = yyvsp[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 173:
#line 1052 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 174:
#line 1055 "gram.y"
{
			ArgType	*args;
			Type	*type;

			for (args = yyvsp[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yyvsp[0].argType;
		    }
break;
case 175:
#line 1080 "gram.y"
{ yyval.argType = 0; }
break;
case 176:
#line 1083 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 177:
#line 1085 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 178:
#line 1088 "gram.y"
{ yyval.argDecl.type = yyvsp[-1].type; yyval.argDecl.name = yyvsp[0].atom; }
break;
case 179:
#line 1090 "gram.y"
{ yyval.argDecl.type = yyvsp[0].type; yyval.argDecl.name = 0; }
break;
case 180:
#line 1093 "gram.y"
{ yyval.bool = True; }
break;
case 181:
#line 1095 "gram.y"
{ yyval.bool = False; }
break;
case 183:
#line 1103 "gram.y"
{ yyval.expr = 0; }
break;
case 185:
#line 1107 "gram.y"
{ 
			DeclList    *decl;

			for (decl = yyvsp[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yyvsp[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yyvsp[0].declList, yyvsp[-1].fulltype.class, yyvsp[-1].fulltype.type, yyvsp[-1].fulltype.publish); 
		    }
break;
case 187:
#line 1124 "gram.y"
{ yyval.expr = NewExprTree(COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 189:
#line 1131 "gram.y"
{ yyval.expr = 0; }
break;
case 190:
#line 1134 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 191:
#line 1136 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 193:
#line 1140 "gram.y"
{ yyval.expr = 0; }
break;
case 194:
#line 1143 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 195:
#line 1145 "gram.y"
{	
			ExprPtr	arg = yyvsp[0].bool ? NewExprTree (DOTDOTDOT, yyvsp[-1].expr, 0) : yyvsp[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 197:
#line 1155 "gram.y"
{ 
			if (yyvsp[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yyvsp[-2].expr, yyvsp[0].expr));
			else
			{
			    ExprPtr left = yyvsp[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yyvsp[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yyvsp[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yyvsp[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yyvsp[-1].ints, yyvsp[-2].expr, yyvsp[0].expr); 
			}
		    }
break;
case 198:
#line 1181 "gram.y"
{   Value	t;
			t = do_Thread_id_to_thread (yyvsp[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yyvsp[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 199:
#line 1192 "gram.y"
{ yyval.expr = NewExprTree(STAR, yyvsp[0].expr, (Expr *) 0); }
break;
case 200:
#line 1194 "gram.y"
{ yyval.expr = NewExprTree(AMPER, yyvsp[0].expr, (Expr *) 0); }
break;
case 201:
#line 1196 "gram.y"
{ yyval.expr = NewExprTree(UMINUS, yyvsp[0].expr, (Expr *) 0); }
break;
case 202:
#line 1198 "gram.y"
{ yyval.expr = NewExprTree(LNOT, yyvsp[0].expr, (Expr *) 0); }
break;
case 203:
#line 1200 "gram.y"
{ yyval.expr = NewExprTree(BANG, yyvsp[0].expr, (Expr *) 0); }
break;
case 204:
#line 1202 "gram.y"
{ yyval.expr = NewExprTree(FACT, yyvsp[-1].expr, (Expr *) 0); }
break;
case 205:
#line 1204 "gram.y"
{ yyval.expr = NewExprTree(INC, yyvsp[0].expr, (Expr *) 0); }
break;
case 206:
#line 1206 "gram.y"
{ yyval.expr = NewExprTree(INC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 207:
#line 1208 "gram.y"
{ yyval.expr = NewExprTree(DEC, yyvsp[0].expr, (Expr *) 0); }
break;
case 208:
#line 1210 "gram.y"
{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 209:
#line 1212 "gram.y"
{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yyvsp[0].expr); }
break;
case 210:
#line 1214 "gram.y"
{ yyval.expr = NewExprTree(PLUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 211:
#line 1216 "gram.y"
{ yyval.expr = NewExprTree(MINUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 212:
#line 1218 "gram.y"
{ yyval.expr = NewExprTree(TIMES, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 213:
#line 1220 "gram.y"
{ yyval.expr = NewExprTree(DIVIDE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 214:
#line 1222 "gram.y"
{ yyval.expr = NewExprTree(DIV, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 215:
#line 1224 "gram.y"
{ yyval.expr = NewExprTree(MOD, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 216:
#line 1226 "gram.y"
{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yyvsp[-2].expr, yyvsp[0].expr)); 
		    }
break;
case 217:
#line 1232 "gram.y"
{ yyval.expr = NewExprTree(SHIFTL, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 218:
#line 1234 "gram.y"
{ yyval.expr = NewExprTree(SHIFTR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 219:
#line 1236 "gram.y"
{ yyval.expr = NewExprTree(QUEST, yyvsp[-4].expr, NewExprTree(COLON, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 220:
#line 1238 "gram.y"
{ yyval.expr = NewExprTree(LXOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 221:
#line 1240 "gram.y"
{ yyval.expr = NewExprTree(LAND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 222:
#line 1242 "gram.y"
{ yyval.expr = NewExprTree(LOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 223:
#line 1244 "gram.y"
{ yyval.expr = NewExprTree(AND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 224:
#line 1246 "gram.y"
{ yyval.expr = NewExprTree(OR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 225:
#line 1248 "gram.y"
{ yyval.expr = NewExprTree(EQ, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 226:
#line 1250 "gram.y"
{ yyval.expr = NewExprTree(NE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 227:
#line 1252 "gram.y"
{ yyval.expr = NewExprTree(LT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 228:
#line 1254 "gram.y"
{ yyval.expr = NewExprTree(GT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 229:
#line 1256 "gram.y"
{ yyval.expr = NewExprTree(LE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 230:
#line 1258 "gram.y"
{ yyval.expr = NewExprTree(GE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 245:
#line 1276 "gram.y"
{ yyval.expr = NewExprConst(TEN_NUM, yyvsp[0].value); }
break;
case 246:
#line 1278 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_NUM, yyvsp[0].value); }
break;
case 247:
#line 1280 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_NUM, yyvsp[0].value); }
break;
case 248:
#line 1282 "gram.y"
{ yyval.expr = NewExprConst(BINARY_NUM, yyvsp[0].value); }
break;
case 249:
#line 1284 "gram.y"
{ yyval.expr = NewExprConst(HEX_NUM, yyvsp[0].value); }
break;
case 250:
#line 1286 "gram.y"
{ yyval.expr = NewExprConst(TEN_FLOAT, yyvsp[0].value); }
break;
case 251:
#line 1288 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_FLOAT, yyvsp[0].value); }
break;
case 252:
#line 1290 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yyvsp[0].value); }
break;
case 253:
#line 1292 "gram.y"
{ yyval.expr = NewExprConst(BINARY_FLOAT, yyvsp[0].value); }
break;
case 254:
#line 1294 "gram.y"
{ yyval.expr = NewExprConst(HEX_FLOAT, yyvsp[0].value); }
break;
case 255:
#line 1296 "gram.y"
{ yyval.expr = NewExprConst(CHAR_CONST, yyvsp[0].value); }
break;
case 256:
#line 1298 "gram.y"
{ yyval.expr = NewExprConst(STRING_CONST, yyvsp[0].value); }
break;
case 257:
#line 1300 "gram.y"
{ yyval.expr = NewExprConst(VOIDVAL, yyvsp[0].value); }
break;
case 258:
#line 1302 "gram.y"
{ yyval.expr = NewExprConst(BOOLVAL, yyvsp[0].value); }
break;
case 259:
#line 1304 "gram.y"
{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 260:
#line 1308 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = yyvsp[-4].type;
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 261:
#line 1316 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr, True); 
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 262:
#line 1323 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr, False);
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 263:
#line 1330 "gram.y"
{
			yyvsp[-1].expr->base.type = NewTypeHash (typePoly, yyvsp[-5].type);
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 264:
#line 1337 "gram.y"
{
			ParseCanonType (yyvsp[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[0].atom, 0, False), 0); 
			yyval.expr->base.type = yyvsp[-2].type;
		    }
break;
case 265:
#line 1343 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); 
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 266:
#line 1349 "gram.y"
{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yyvsp[0].value)); }
break;
case 267:
#line 1351 "gram.y"
{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 268:
#line 1353 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 269:
#line 1355 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 270:
#line 1357 "gram.y"
{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yyvsp[-3].expr, (Expr *) 0), yyvsp[-1].expr); }
break;
case 271:
#line 1359 "gram.y"
{ yyval.expr = NewExprTree(OS, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 272:
#line 1361 "gram.y"
{ yyval.expr = NewExprTree (OP, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 273:
#line 1363 "gram.y"
{ yyval.expr = NewExprTree(DOT, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 274:
#line 1365 "gram.y"
{ yyval.expr = NewExprTree(ARROW, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 275:
#line 1367 "gram.y"
{ 
			ParseCanonType (yyvsp[-5].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yyvsp[-5].type, yyvsp[-2].argType, yyvsp[-1].expr), 0); 
		    }
break;
case 277:
#line 1374 "gram.y"
{ yyval.value = Zero; }
break;
case 284:
#line 1387 "gram.y"
{ yyval.expr = 0; }
break;
case 285:
#line 1389 "gram.y"
{ yyval.expr = 0; }
break;
case 286:
#line 1392 "gram.y"
{ 
			ExprPtr	elts = yyvsp[-3].expr ? ExprRehang (yyvsp[-3].expr, 0) : 0;
			if (yyvsp[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 287:
#line 1406 "gram.y"
{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yyvsp[-5].expr, yyvsp[-4].expr), yyvsp[-2].expr);
		    }
break;
case 288:
#line 1411 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 290:
#line 1415 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 292:
#line 1419 "gram.y"
{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yyvsp[0].atom);
			yyval.expr = NewExprAtom (yyvsp[0].atom, s, False); 
		    }
break;
case 293:
#line 1427 "gram.y"
{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 294:
#line 1436 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 295:
#line 1438 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 299:
#line 1449 "gram.y"
{ yyval.expr = 0; }
break;
case 300:
#line 1451 "gram.y"
{ yyval.expr = 0; }
break;
case 301:
#line 1454 "gram.y"
{
			ExprPtr elts = yyvsp[-2].expr ? ExprRehang (yyvsp[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 302:
#line 1460 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 303:
#line 1462 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 304:
#line 1465 "gram.y"
{ yyval.expr = NewExprTree (DARROW, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 305:
#line 1467 "gram.y"
{ yyval.expr = NewExprTree (DARROW, 0, yyvsp[0].expr); }
break;
case 308:
#line 1476 "gram.y"
{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yyvsp[-2].expr, 0), 0); }
break;
case 309:
#line 1479 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 310:
#line 1481 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 311:
#line 1484 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 312:
#line 1486 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 316:
#line 1493 "gram.y"
{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4090 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
